
#include "TF1.h"
#include "TH1F.h"
#include "TFile.h"
#include <vector>
#include "TNtuple.h"
#include "TROOT.h"

// #include <iostream>
// #include "TLorentzVector.h"

using namespace std;

class particle
{
public:
	particle() : feTot(0), fPx(0), fPy(0), fPz(0), fId(0), fWeight(0) {}
	Float_t feTot;
	Float_t fPx;
	Float_t fPy;
	Float_t fPz;
	Int_t   fId;
	Float_t fWeight;
};

class event
{
public:
	event() : fEvNumber(0), fMult(0), feTot(0), fImpPar(0), fWeight(0) {}
	Int_t   fEvNumber;
	Int_t   fMult;
	Float_t feTot;
	Float_t fImpPar;
	Float_t fWeight;
	std::vector<particle> fPart;
};

int lh2tree(TString inputFile, TString outputFile="")
{
	gROOT->Reset();

//	/*TString */inputFile = TString("LesHouches.Real.00000001.xml");  // TString(argv[2]);

	if (outputFile.Length()==0)
	{
		outputFile = inputFile;
		outputFile.ReplaceAll(".xml", ".root");
	}

	event * ev = new event;
  
	FILE *pFile = fopen(inputFile.Data(),"r");
	TFile * pFileOut = new TFile(outputFile,"recreate");

	TTree * tree = new TTree("gibuu", "GiBUU data");
	tree->Branch("event", "event", &ev, 0);
  
	//reading initial lines
	char str[300];
	for (Int_t jj = 1; jj<10; jj++)
	{
		fscanf(pFile, "\n%[^\n]", str);
	}

	Int_t nreac = 0;
  
	for(Int_t iev=1; iev <= 100000000; iev++)
	{
		//cout<<"iev = "<<iev<<endl;
		++nreac;
	
		char str[300];
		Float_t weight;
	
		fscanf(pFile, "%d %*d %f %f %f %f\n",
			&ev->fMult, &weight, &ev->fImpPar, &ev->fWeight, &ev->fWeight);

		if (ev->fMult == -1) break;

		ev->fPart.clear();

		particle par;

		for(Int_t i = 0; i < ev->fMult; ++i)
		{
			fscanf(pFile, "%d %*d %*d %*d %*d %*d",
   				&par.fId);

			fscanf(pFile, "%f %f %f %f %*f %*f %*f\n",
	   			&par.fPx, &par.fPy, &par.fPz, &par.feTot);

			ev->fPart.push_back(par);
		}

		tree->Fill();

		fgets(str, 1, pFile);
		if (strcmp(str, "#"))
			fscanf(pFile, "%[^\n]", str);

		fscanf(pFile, "\n%[^\n]", str); 
		fscanf(pFile, "\n%[^\n]", str);


		ev->fMult = -1;
    
	}//event cycle
  
	//tree->Print();

	pFileOut->Write(); pFileOut->Close();

	return 0;
}
